Subject: Re: gitoxide-compatible licensing of Git's Rust code, was Re: [PATCH 6/7] xdiff: conditionally use Rust's implementation of xxhash

From: Phillip Wood <[email-masked]>
Date: Fri, 3 Oct 2025 10:51:47 +0100

On 03/10/2025 04:18, Jeff King wrote:
> On Fri, Sep 26, 2025 at 11:06:38AM +0100, Phillip Wood wrote:
> 
>>> If I understand the suggestion correctly, it's not to license it
>>> specifically to GitOxide. It's to use a permissive license (like GPL
>>> with linking exception) that would make it compatible with other
>>> projects with similar licenses (like GitOxide).
>>
>> I was responding to this paragraph in Johannes' message
>>
>>      Note the exception? For new Rust code (and of course excluding code
>>      that has been ported verbatim from GPLv2-licensed code), GPL v2
>>      could be used with an exception along these lines: This file is
>>      licensed under the GPL v2, with the exception that it can be freely
>>      used in the Gitoxide project.
>>
>> That suggestion is pretty close to what libgit2 has in its git.git-authors
>> file[1]. I'm not sure how practical it is to special case just one project
>> though.
> 
> Ah, yeah, I may have misunderstood the proposal then.
> 
> I don't think that really changes much with respect to my concern, which
> is for existing code.

I agree it doesn't change anything with regard to that, I think it just 
adds more potential problems.
> That probably needs to be explicitly granted
> permission to relicense, whether to a specific project or not, and it is
> hard to pinpoint a definitive author for a lot of it (even if many
> authors have agreed to relicensing) because it has been touched by so
> many people over the years.
> 
> So there are probably two separate legal issues to consider:
> 
>    - how the explicit re-licensing grant is worded
> 
>    - what problems may came up with porting existing code that has been
>      touched by many people

If we want to seriously consider this we should probably reach out to 
Conservancy for some advice. Did this end up being discussed at the 
Contributor's Summit?

Thanks

Phillip